/*****************************************************************************
 * Module    : TaskSub
 * File      : tasksub_mic_record.c
 * Author    : Hanny
 * Function  :  - 
 *****************************************************************************/
#ifdef TASK_SUB

//¼ʹ
#define DBG_TASK_RECORD(...)          //printf(__VA_ARGS__)
#define RECORD_DIR_NAME_LEN    MIC_DIR_NAME_LEN


#pragma constseg="TASK_RECORD_1_CONST"
IAR_CONST char str_mic_rec_dir[] = "RECORD";

#if (RECORD_FILE_NAME == SHORT_NAME)
IAR_CONST char str_mic_rec_file[] = "RECORD/REC0001.WAV";
#define REC_FNAME_NUM_LEN           4                               //ļųȣ4λ
#define MIC_FNAME_NUM_OFS           (sizeof(str_mic_rec_file)-8-1)  //ļλãܳȥ0001.MP3\0
#else
#define REC_FNAME_NUM_LEN           4                               //ļųȣ4λ
#define MIC_FNAME_NUM_OFS           sizeof(str_mic_rec_dir)         //ļλã"RECORD/"֮
IAR_CONST u8 long_name_file[] = {
    //ļǰ8ַʹÿոspace
    0x30, '0', '0', '1', 0xBD, 0xA8, 0x7E, 0x31, '.', 'w', 'a', 'v', '\0',
    //ļ,ҪWinhex鿴
#if 1
  //             0          0            1                                        
    0x30, 0x00, '0',  0x00, '0',  0x00, '1',  0x00, 0xfa, 0x5e, 0x63, 0x83, 0xe0, 0x73, 0x77, 0x6d,
  //                              ˾          -           2           0           1
    0x09, 0x67, 0x50, 0x96, 0x6c, 0x51, 0xf8, 0x53, 0x2d, 0x00, 0x32, 0x00, 0x30, 0x00, 0x31, 0x00,
  //3                     4                     2                     .           W
    0x33, 0x00, 0x74, 0x5e, 0x34, 0x00, 0x08, 0x67, 0x32, 0x00, 0xe5, 0x65, 0x2e, 0x00, 0x57, 0x00,
  //A           V
    0x41, 0x00, 0x56, 0x00,
#else
//              1            0           0                              .           W
    0x30, 0x00, '1',  0x00, '0',  0x00, '0',  0x00, 0xfa, 0x5e, 0x63, 0x83, 0x2e, 0x00, 0x57, 0x00,
//  A           V
    0x41, 0x00, 0x56, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff,
#endif
};
#endif
IAR_CONST u16 tbl_wav_spr[6] = {48000L, 32000L, 24000L, 16000L, 12000L, 8000L};
#pragma constseg=default

#pragma constseg="TASK_RECORD_CONST"
#if (REC_TYPE == REC_WAV_ADPCM)
IAR_CONST u8 tbl_wav_head[52] = {
    0x52, 0x49, 0x46, 0x46, 0x00, 0x00, 0x00, 0x00, 0x57, 0x41, 0x56, 0x45, 0x66, 0x6D, 0x74, 0x20,
    0x14, 0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x04, 0x00, 0x02, 0x00, 0x00, 0x00, 0x66, 0x61, 0x63, 0x74, 0xC8, 0x01, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
};
#else
IAR_CONST u8 tbl_wav_head[52] = {
    0x52, 0x49, 0x46, 0x46, 0x00, 0x00, 0x00, 0x00, 0x57, 0x41, 0x56, 0x45, 0x66, 0x6D, 0x74, 0x20,
    0x14, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x10, 0x00, 0x02, 0x00, 0x00, 0x00, 0x66, 0x61, 0x63, 0x74, 0xC8, 0x01, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00,
};
#endif
#pragma constseg=default
IAR_XDATA_A type_task_rec t_rec @ "RECORD_XDATA";

#pragma location="MIC_PROC"
__near_func void task_record_process(void)
{
    if (t_rec.block_cnt >= t_rec.block_lmt) {
        //printf("err\n");
        return;
    }
    if (!t_rec.pos) {
        adpcm_input = (u16)adc_buf;
    }
#if (REC_TYPE == REC_WAV_ADPCM)
    adpcm_encode(t_rec.slice+t_rec.pos, t_rec.pos);
    if (t_rec.pos) {
        t_rec.block_cnt++;
        if (adpcm_output == ((u16)wav_en_out_buf+WAV_OUT_BUF_SIZE)) {
            adpcm_output = (u16)wav_en_out_buf;
        }
    }
#else
    else
        adpcm_input = (u16)&adc_buf[128];
    memcpy((u8*)adpcm_output,(u8*)adpcm_input,128);
    adpcm_output += 128;
    t_rec.block_cnt++;
    if (adpcm_output == ((u16)wav_en_out_buf+WAV_OUT_BUF_SIZE)) {
        adpcm_output = (u16)wav_en_out_buf;
    }
#endif
    t_rec.pos ^= 1;
}

#pragma location="TASK_RECORD_SEG"
bool wav_write_header(void *buf)
{
    t_rec.file_size = fat_file.fsize;

    my_memset((void *)buf, 0, 512);
    smemcpy_c((void *)buf, (void __code *)tbl_wav_head, 52);

    u32 *ptr0 = (u32 *)buf;
    ptr0[1] = t_rec.file_size - 8;
    ptr0[6] = t_rec.spr;
    ptr0[7] = (t_rec.spr * BLOCK_SIZE) / t_rec.spl;
    ptr0[12] = ((t_rec.file_size - 512) * t_rec.spl) / BLOCK_SIZE;
    ptr0[126] = 0x61746164;
    ptr0[127] = t_rec.file_size - 512;

    u16 *ptr1 = (u16 *)buf;
    ptr1[11] = adpcm_channel;
    ptr1[16] = BLOCK_SIZE;
    ptr1[19] = t_rec.spl;

    //printf("ssect=%08lx\n", t_rec.file_ssect);
    if (fat_fs.disk_write(buf, t_rec.file_ssect)) {
        return false;
    }
    return true;
}

#pragma location="TASK_RECORD_SEG"
bool wav_close_file(void)
{
    if(!wav_write_header(wav_en_header_buf)) {
        return false;
    }
    if(!f_close()) {
        return false;
    }
    return true;
}



#pragma location="TASK_RECORD_SEG"
void wav_record_stop(void)
{
    mic_adc_stop();
    if (!wav_close_file()) {
        //printf("close Fail!\n");
    }
}

#pragma location="TASK_RECORD_SEG"
bool wav_sync_file(void *buf)
{
    if (!move_window(0)) {
        return false;
    }

    if(!wav_write_header(buf)) {
        return false;
    }
    if(fat_fs.disk_read(buf, fat_file.dir_sect)) {
        return false;
    }
    u8 *dir;
    dir = (u8 *)buf + (fat_file.dir_ptr - fat_fs.win);
    if(fat_fs.fs_type == FS_EXFAT) {
        mkitem_exfat(dir, (char *)fat_file.fname, AM_ARC, fat_file.org_clust, t_rec.file_size);
    } else {
        mkitem_fat(dir, (char *)fat_file.fname, dir[DIR_Attr]|AM_ARC, fat_file.org_clust, t_rec.file_size);
    }
    if(fat_fs.disk_write(buf, fat_file.dir_sect)) {
        return false;
    }
    return true;
}

//¼ʼ
#pragma location="TASK_RECORD_SEG_1"
void task_record_wav_init(void)
{
    if (t_rec.file_open) {
        f_close();
    }
    //ѡMIC¼
    mic_init(SEL_RECMIC);
    t_rec.rec_time = 0;                                 //ʱ0
    t_rec.file_open = 0;
    t_rec.dir_open = 0;
}


#pragma location="TASK_RECORD_SEG_1"
bool record_fname_inc(u8 *buf)
{
    u8 i;
    u8 *p = buf + (REC_FNAME_NUM_LEN-1);

    *p += 1;
    for(i=0; i<(REC_FNAME_NUM_LEN-1); i++) {
        if(*p > '9') {
            *p-- = '0';
            *p += 1;
        } else {
            return true;
        }
    }

    return (*p > '9')? false : true;
}


#pragma location="TASK_RECORD_SEG_1"
u8 task_record_copy_name(void)
{
#if (RECORD_FILE_NAME == SHORT_NAME)
        memcpy(filename, (char *)str_mic_rec_file, sizeof(str_mic_rec_file));
        return MIC_FNAME_NUM_OFS;
#else
        memcpy(filename, (char *)str_mic_rec_dir, sizeof(str_mic_rec_dir));
        t_rec.sname_ptr = sizeof(str_mic_rec_dir) - 1;
        t_rec.lname_ptr = t_rec.sname_ptr + 14;
        //ļʹõgbk룬ļʹõunicode
        filename[t_rec.sname_ptr]='/';
        smemcpy_c((void *)(filename+t_rec.sname_ptr+1), (void __code *)long_name_file, sizeof(long_name_file));
#endif
}

//ļ½ļ
#pragma location="TASK_RECORD_SEG_1"
bool task_record_create(void)
{
    u8 file_creat = 0;
    t_rec.file_open = 0;
    u8 rec_fname_ofs = task_record_copy_name();
    while (1) {
#if (RECORD_FILE_NAME == LONG_NAME)
        file_creat = f_create_long_name(filename,t_rec.lname_ptr);
#else
        file_creat = f_create(filename);
#endif
        if (file_creat == 1) {
            //printf(str_rec_create_ok, filename);
            break;
        } else if(file_creat == 0) {
            if(!record_fname_inc((u8 *)&filename[rec_fname_ofs])) {
                //printf(str_rec_create_fail, filename);
                return false;
            }
#if (RECORD_FILE_NAME == LONG_NAME)
            filename[t_rec.lname_ptr+0] = filename[t_rec.sname_ptr+1];
            filename[t_rec.lname_ptr+2] = filename[t_rec.sname_ptr+2];
            filename[t_rec.lname_ptr+4] = filename[t_rec.sname_ptr+3];
            filename[t_rec.lname_ptr+6] = filename[t_rec.sname_ptr+4];
#endif
        } else if (file_creat == 2) {
            //printf(str_rec_disk_full);
            return false;
        }
    }
    t_rec.file_open = 1;
    return true;
}



#pragma location="TASK_RECORD_SEG_1"
bool task_record_dirmake(void)
{
    char dir_name[sizeof(str_mic_rec_dir)];
    memcpy(dir_name, (char *)str_mic_rec_dir, sizeof(str_mic_rec_dir));
    return f_mkdir(dir_name);
}

#pragma location="TASK_RECORD_SEG_1"
bool wav_record_init(void)
{
    //Ԥ512byteдļͷ
    my_memset((void *)wav_en_header_buf, 0, 512);
    if(f_write((void *)wav_en_header_buf)) {
        msgbox(STR_WRITE_DISABLE, NULL, MSGBOX_TIME);
        DBG_TASK_RECORD("write fail\n");
        return false;
    }
    t_rec.file_ssect = clust2sect(fat_file.org_clust);
    fat_file.sclust = fat_file.org_clust;
    //printf("file_ssect1=%08lx, sclust=%08lx\n", t_rec.file_ssect, fat_file.org_clust);

    t_rec.spr = tbl_wav_spr[SDADC_SPR_MREC];
    t_rec.chs = 1;
    t_rec.spl = RECORD_SAMPLES;
    t_rec.pos = 0;
    t_rec.block_cnt = 0;
    t_rec.block_adr = wav_en_out_buf;
    t_rec.block_lmt = WAV_OUT_BUF_SIZE/BLOCK_SIZE;
    t_rec.slice = t_rec.spl >> 4;

    adpcm_channel = t_rec.chs;
    adpcm_index[0] = 0;
    adpcm_index[1] = 0;
    adpcm_output = (u16)wav_en_out_buf;

    return true;
}

//ʼ¼
#pragma location="TASK_RECORD_SEG_1"
u8 task_record_start(void)
{
    if(!record_mount_device()) {
        return 1;       //err
    }
    if(!t_rec.dir_open) {
#if IS_LCD_DISPLAY
        draw_wait();            // ֻһ"Ժ"
#endif
        t_rec.dir_open = task_record_dirmake();
        if(!t_rec.dir_open) {
            return 1;   //make dir fail
        }
    }
    if (!fs_writable()) {
        return 1;
    }
    if (!t_rec.file_open) {
        if(!task_record_create()) {
            return 2;   //disk full
        }
        if (!wav_record_init()) {
            return 1;
        }
        t_rec.file_open = 1;
    }
    return 0;
}


//ͣ¼
#pragma location="TASK_RECORD_SEG_1"
void task_record_pause(void)
{
    mic_adc_stop();
    wav_sync_file(wav_en_header_buf);
    t_rec.pos = 0;
    t_rec.block_cnt = 0;
    t_rec.block_adr = wav_en_out_buf;
    t_rec.sync_cnt = 0;
    adpcm_index[0] = 0;
    adpcm_index[1] = 0;
    adpcm_output = (u16)wav_en_out_buf;
    t_rec.rec_sta = REC_STA_PAUSE;
}

//ֹͣ¼
#pragma location="TASK_RECORD_SEG_1"
void task_record_stop(void)
{
    if(t_rec.file_open) {
        wav_record_stop();
    }
    t_rec.file_open = 0;
    t_rec.dir_open = 0;
    t_rec.rec_time = 0;                                 //ʱ0
    t_rec.rec_sta = REC_STA_STOP;
}


//¼
#pragma location="TASK_RECORD_SEG"
void tasksub_mic_rec_event(void)
{
    WATCHDOG_CLR();
    comm_event();
    if (t_rec.block_cnt < 4) {
        return;
    }
    memcpy(rec_write_buf,t_rec.block_adr,512);
   	u8 res = f_write(rec_write_buf);
  // if(t_rec.block_adr == &wav_en_out_buf[6656])
   //    printf_array(t_rec.block_adr,1);
    if (res) {
        if (res == 6) {
            //ֹͣ¼
            DBG_TASK_RECORD("disk full!\n");
            task_record_stop();
            //t_rec.rec_sta = REC_STA_STOPPING;           //ֹͣ¼
        } else {
            //¼ֹͣ¼
            DBG_TASK_RECORD("write err!\n");
           // wav_record_abort();
            task_ctl.dev_change = 1;
            t_rec.file_open = 0;
            t_rec.rec_sta = REC_STA_STOPPING;           //¼ֹͣ¼
        }
        t_rec.play_flag = 1;
        task_record_stop();
        return;
    }

    t_rec.block_cnt -= 4;
    t_rec.block_adr += 0x200;
    if (t_rec.block_adr == &wav_en_out_buf[WAV_OUT_BUF_SIZE]) {
        t_rec.block_adr = wav_en_out_buf;
    }


#if MUSIC_MODE_AUTO
    if (device_need_activate(DEVICE_SDMMC) || device_need_activate(DEVICE_UDISK)) {
        if(task_ctl.work_sta == TASK_MUSIC) {           //U̻SDʱģʽ
            task_ctl.work_sta = task_ctl.last_work;
        }
    }
#endif
    if (device_change()) {
        if(t_rec.rec_sta == REC_STA_RECORD) {
            t_rec.play_flag = 0;
            t_rec.file_open = 0;
            t_rec.dir_open = 0;
            mic_adc_stop();
            t_rec.rec_sta = REC_STA_STOP;           //豸䶯ֹͣ¼
        }
    }
}


//¼ʼ
#pragma location="TASK_RECORD_SEG_1"
void tasksub_mic_rec_enter(void)
{
    u8 res;
    set_sys_clk(SYS_24M);
    //״̬
    ocx_clear();
    led_busy();
#if !IS_LCD_DISPLAY
    draw_wait();
#endif
    res = task_record_start();
    flush_msg();                        //Ϣ
    if(res == 2) {
        show_full();
        //printf(str_rec_err);
        WATCHDOG_CLR();
        delay_5ms(200);
        return;
    } else if(res == 1) {
        show_err();
        t_rec.rec_sta = REC_STA_STOP;
        //printf(str_rec_err);
        WATCHDOG_CLR();
        delay_5ms(200);
        return;
    } else {
        //printf("rec_start\n");
        mic_adc_start();
        t_rec.rec_sta = REC_STA_RECORD;
        ocx_show_cnt = 0;//¼˸ʱ
#if IS_LCD_DISPLAY
        // "Ժ"
        line_clear();
        line_update(2);
        line_update(4);
        t_rec.updata_flag = 1;      // ø±־,ʾ¼ͼ
        task_mic_display();         // ʾ1ΣȻҪ¼1sʾ
#endif
    }
}


//˳¼
#pragma location="TASK_RECORD_SEG_1"
void tasksub_mic_rec_exit(void)
{
    if (t_rec.rec_sta != REC_STA_STOP && t_rec.rec_sta != REC_STA_PAUSE) {
        task_record_stop();
    }
    if(t_rec.play_flag)
    {
        memcpy(filename, &filename[sizeof(str_mic_rec_dir)],13);
    }
#if IS_LCD_DISPLAY
        t_rec.updata_flag = 1;      // ø±־,ʾֹͣͣͼ
#endif
    led_idle();
    ocx_clear();
}

#pragma location="TASK_RECORD_SEG"
void tasksub_mic_rec_loop(void)
{
    u8 msg;
    while (task_ctl.work_sta == TASK_MIC && t_rec.rec_sta == REC_STA_RECORD) {
        tasksub_mic_rec_event();
        while (msg = get_msg()) {
            tasksub_record_deal_msg(msg);
        }
        tasksub_record_display();
    }
}

#pragma location="TASK_RECORD_SEG"
void tasksub_mic_record(void)
{
    //printf("tasksub_rec_ring\n");
    tasksub_mic_rec_enter();
    tasksub_mic_rec_loop();
    tasksub_mic_rec_exit();
   // printf("tasksub_bt_rec exit\n");
}
#endif
