/*****************************************************************************
 * Module    : User
 * File      : user_bt.h
 * Author    : Hanny
 * Function  : ûAPIӿ
 *****************************************************************************/
#ifndef USER_BT_H
#define USER_BT_H

#define BT_RFINFO_SET           0x06
#define BT_RFINFO_MIC           0x0a
#define BT_RFINFO_NAME          0x0e
#define BT_RFINFO_ADDR          0x2e
#define BT_RFINFO_VOICE         0x40

#if BT_SAMPLERATE_16K
    #define BT_VIOCE_SAMPLES    256
#else
    #define BT_VIOCE_SAMPLES    128
#endif

//BT_RFINFO_SET BIT
#define BT_RFINFO_SET_NAME      0
#define BT_RFINFO_SET_ADDR      1
#define BT_RFINFO_SET_VOICE     2
#define BT_RFINFO_SET_MIC       3
#define BT_RFINFO_SET_DYADDR    6

/*****************************************************************************
 * Module    : ϢƫƵַΪ˷䣬0Ч1ʼ
 *****************************************************************************/
#define BT_PARAM_LATEST             0       //һЧ        1byte
#define BT_PARAM_ORDER              4       //Ϣ                  16byte
#define BT_PARAM_PAIRS              20      //Ϣ                      58byte x 4 = 232byte
//ÿϢƫƵַ
#define BT_PAIR_NUM                 4       //֧4Ϣ
#define BT_PAIR_SIZE                58                                                  //Ϣ58Byte
#define BT_PAIR_VALID(n)            ((BT_PAIR_SIZE * (n)) + BT_PARAM_PAIRS)             //ϢǷЧ      1byte
#define BT_PAIR_ADDR(n)             ((BT_PAIR_SIZE * (n)) + BT_PARAM_PAIRS + 4)         //ַ              6byte
#define BT_PAIR_LINK_KEY(n)         ((BT_PAIR_SIZE * (n)) + BT_PARAM_PAIRS + 10)        //link key          16byte
#define BT_PAIR_NAME(n)             ((BT_PAIR_SIZE * (n)) + BT_PARAM_PAIRS + 26)        //              26byte

typedef struct __TYPE_BT_PAIR {
    u8 valid;                               //һЧ
    u8 reserved[3];
    u8 addr[6];
    u8 link_key[16];
    u8 name[32];
} TYPE_BT_PAIR;

typedef struct __TYPE_BT_PARAM_PAIR {
    u8 latest;                              //һЧ
    u8 reserved[3];
    u8 order[16];
    TYPE_BT_PAIR pair[4];
} TYPE_BT_PARAM_PAIR;

typedef struct {
    u8 disp_bt_sta;
    u8 disp_dev_bat;                //ƻ豸ʾֵ
    u8 add_sco_flag;                //жǷѾadd_sco
    u8 hid_enable;                  //ǷHID
} type_bt;

extern type_bt t_bt;
extern bool bt_play_status;
void user_bt_init(void);
void user_bt_off(void);
void user_bt_event(void);
u8 bt_status_get(void);             //·װ״̬ȡ
void bt_pause_play(void);           //ֲ/ͣ

bool bt_hid_photo(void);

void btinfo_get_name(u8 *ptr);
void btinfo_get_addr(u8 *ptr);
void btinfo_get_rfparam(u8 *ptr);
void btinfo_get_mic(u8 *ptr);
void btinfo_get_voice(u8 *ptr);
void spp_tx(u8 *ptr, u8 len);               //SPPͽӿ

extern volatile u8 bt_sleep_cnt;             //BTģģʽ
void send_bat_to_iphone_hook(void);
#endif
